import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, TemplateRef, ViewContainerRef } from '@angular/core';
import { Overlay, OverlayPositionBuilder } from '@angular/cdk/overlay';
import { Subject } from 'rxjs';
import { AnimationEvent } from '@angular/animations';
import { BreakpointObserver } from '@angular/cdk/layout';
import { BooleanInput } from '@angular/cdk/coercion';
import * as i0 from "@angular/core";
export declare class MdbDropdownDirective implements OnDestroy, AfterContentInit {
    private _overlay;
    private _overlayPositionBuilder;
    private _elementRef;
    private _vcr;
    private _breakpointObserver;
    private _cdRef;
    _template: TemplateRef<any>;
    _dropdownToggle: ElementRef;
    _dropdownMenu: ElementRef;
    get animation(): boolean;
    set animation(value: boolean);
    private _animation;
    offset: number;
    closeOnOutsideClick: boolean;
    closeOnItemClick: boolean;
    closeOnEsc: boolean;
    withPush: boolean;
    dropdownShow: EventEmitter<MdbDropdownDirective>;
    dropdownShown: EventEmitter<MdbDropdownDirective>;
    dropdownHide: EventEmitter<MdbDropdownDirective>;
    dropdownHidden: EventEmitter<MdbDropdownDirective>;
    private _overlayRef;
    private _portal;
    private _open;
    private _isDropUp;
    private _isDropStart;
    private _isDropEnd;
    private _isDropdownMenuEnd;
    private _xPosition;
    private _breakpoints;
    readonly _destroy$: Subject<void>;
    _breakpointSubscription: any;
    _animationState: string;
    constructor(_overlay: Overlay, _overlayPositionBuilder: OverlayPositionBuilder, _elementRef: ElementRef, _vcr: ViewContainerRef, _breakpointObserver: BreakpointObserver, _cdRef: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    private _bindDropdownToggleClick;
    private _createOverlayConfig;
    private _createOverlay;
    private _createPositionStrategy;
    private _getPosition;
    private _listenToEscKeyup;
    private _listenToClick;
    onAnimationEnd(event: AnimationEvent): void;
    private _subscribeBrakpoints;
    show(): void;
    private _handleKeyboardNavigation;
    hide(): void;
    toggle(): void;
    static ngAcceptInputType_animation: BooleanInput;
    static ɵfac: i0.ɵɵFactoryDeclaration<MdbDropdownDirective, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<MdbDropdownDirective, "[mdbDropdown]", never, { "animation": { "alias": "animation"; "required": false; }; "offset": { "alias": "offset"; "required": false; }; "closeOnOutsideClick": { "alias": "closeOnOutsideClick"; "required": false; }; "closeOnItemClick": { "alias": "closeOnItemClick"; "required": false; }; "closeOnEsc": { "alias": "closeOnEsc"; "required": false; }; "withPush": { "alias": "withPush"; "required": false; }; }, { "dropdownShow": "dropdownShow"; "dropdownShown": "dropdownShown"; "dropdownHide": "dropdownHide"; "dropdownHidden": "dropdownHidden"; }, ["_dropdownToggle", "_dropdownMenu"], ["*", ".dropdown-toggle", ".dropdown-menu"], false, never>;
}
